#ifndef AUBO_SCOPE_EXTENSION_INFO_H
#define AUBO_SCOPE_EXTENSION_INFO_H

#include <string>
#include <aubo_caps/class_forward.h>

namespace arcs {
namespace aubo_scope {
ARCS_CLASS_FORWARD(URCapInfo);

/**
 * This interface provides various metadata information about an installed
 * URCap, such as the name of the URCap.
 *
 * @since 1.1.0
 */
class ARCS_ABI_EXPORT URCapInfo
{
public:
    virtual ~URCapInfo() = default;

    /**
     * @return The symbolic name (id) of the URCap.
     */
    virtual std::string getSymbolicName() = 0;

    /**
     * @return The name of the URCap.
     */
    virtual std::string getName() = 0;

    /**
     * @return The vendor of the URCap.
     */
    virtual std::string getVendor() = 0;
};
} // namespace aubo_scope
} // namespace arcs

#endif
